#!/usr/bin/perl -w
use DBI;
use Getopt::Long;

$db_user    = "";
$db_passwd  = "";
$db_name = "";
$db_host = "localhost";
$db_port = "3306";

 
%month=('Jan','01','Feb','02','Mar','03','Apr','04','May','05','Jun','06','Jul','07','Aug','08','Sep','09','Oct','10','Nov','11','Dec','12');

$action="";
$hostname="";
$ip_address="";
$ethernet_address="";
$ethernet_vendor="";
$old_ethernet_address="";
$old_ethernet_vendor="";
$timestamp="";
$previous_timestamp="";
$delta="";

GetOptions ("f=s" => \$file, "file=s" => \$file);

open (QUEUE,"/dev/fd/0");
while ($string=<QUEUE>) {
    chomp $string;
    for ($string) {
	s/^\s+//;
	s/\s+$//;
    }
    if (substr($string,0,7) eq "Subject"){
	@s=split(" ",substr($string,9));
	$action="$s[0] $s[1]";
    }
    if (substr($string,0,8) eq "hostname"){
	$hostname=substr($string,10);
    }
    if (substr($string,0,10) eq "ip address"){
	$ip_address=substr($string,12);
    }
    if (substr($string,0,16) eq "ethernet address"){
	@mac=split "\:",substr($string,18);
	$m=();
	foreach $o (@mac){
	    push @m,sprintf("%02X",hex($o));
	}
	$ethernet_address="$m[0]:$m[1]:$m[2]:$m[3]:$m[4]:$m[5]";
    }
    if (substr($string,0,15) eq "ethernet vendor"){
	$ethernet_vendor=substr($string,17);
    }
    if (substr($string,0,20) eq "old ethernet address"){
	@mac=split "\:",substr($string,22);
	@m=();
	foreach $o (@mac){
	    push @m,sprintf("%02X",hex($o));
	}
	$old_ethernet_address="$m[0]:$m[1]:$m[2]:$m[3]:$m[4]:$m[5]";
    }
    if (substr($string,0,19) eq "old ethernet vendor"){
	$old_ethernet_vendor=substr($string,21);
    }
    if (substr($string,0,9) eq "timestamp"){
	@stamp=split /\,/,substr($string,11);
	@md=split " ",$stamp[1];
	$day = sprintf("%02d", $md[1]);
	@yt=split " ",$stamp[2];
	$timestamp="$yt[0]-$month{substr($md[0],0,3)}-$day $yt[1]";
    }
    if (substr($string,0,18) eq "previous timestamp"){
	@stamp=split /\,/,substr($string,20);
	@md=split " ",$stamp[1];
	$day = sprintf("%02d", $md[1]);
	@yt=split " ",$stamp[2];
	$previous_timestamp="$yt[0]-$month{substr($md[0],0,3)}-$day $yt[1]";
    }
    if (substr($string,0,5) eq "delta"){
	$delta=substr($string,7);
    }
}
close QUEUE;
$dbh = DBI->connect ("DBI:mysql:database=$db_name;host=$db_host;port=$db_port", $db_user, $db_passwd) or die "$0: could not connect to mysql";
$ini=$dbh->do(qq{SET NAMES koi8r});
if ($action eq "flip flop"){
    $ini=$dbh->prepare(qq{insert into flip_flop (hostname,ip_address,ethernet_address,ethernet_vendor,old_ethernet_address,old_ethernet_vendor,timestamp,previous_timestamp,delta) values('$hostname','$ip_address','$ethernet_address','$ethernet_vendor','$old_ethernet_address','$old_ethernet_vendor','$timestamp','$previous_timestamp','$delta')});
    $ini->execute;
}
if ($action eq "changed ethernet"){
    $ini=$dbh->prepare(qq{insert into changed_ethernet_address (hostname,ip_address,ethernet_address,ethernet_vendor,old_ethernet_address,old_ethernet_vendor,timestamp,previous_timestamp,delta) values('$hostname','$ip_address','$ethernet_address','$ethernet_vendor','$old_ethernet_address','$old_ethernet_vendor','$timestamp','$previous_timestamp','$delta')});
    $ini->execute;
    $ini=$dbh->prepare(qq{insert into new_station (hostname,ip_address,ethernet_address,ethernet_vendor,timestamp) values('$hostname','$ip_address','$ethernet_address','$ethernet_vendor','$timestamp')});
#    $ini=$dbh->prepare(qq{update new_station set ethernet_address='$ethernet_address', ethernet_vendor='$ethernet_vendor', timestamp='$timestamp' where ip_address='$ip_address')});
    $ini->execute;
}
if ($action eq "new station"){
    $ini=$dbh->prepare(qq{insert into new_station (hostname,ip_address,ethernet_address,ethernet_vendor,timestamp) values('$hostname','$ip_address','$ethernet_address','$ethernet_vendor','$timestamp')});
    $ini->execute;
}
if ($action eq "new activity"){
    $ini=$dbh->prepare(qq{insert into new_activity (hostname,ip_address,ethernet_address,ethernet_vendor,timestamp) values('$hostname','$ip_address','$ethernet_address','$ethernet_vendor','$timestamp')});
    $ini->execute;
}
